# Programm zur Durchfuehrung der Optimierung und Analyse


$filenameAnalyzation="analysis.txt";
$filenameOutput="output/kip_main-detail.txt";
$filenameRegularScript="scripts/kip_main.pl";
$filenameGapScript="scripts/kip_gapAnalyzation.pl";
$filenameGap="output/kip_gapAnalyzation.txt";
$filenameEconstraintScript="scripts/kip_eConstraint.pl";
$filenameEconstraint="output/kip_eConstraint.txt";
$filenameEconstraintScript2="scripts/kip_eConstraint2.pl";
$filenameEconstraint2="output/kip_eConstraint2.txt";
$filenameInput="input/main.txt";
$filenameError="output/error.txt";
$filenameLog="output/log.txt";

$one=1;
$zeros4=0.0001;				# "Zahl mit 4 Nullen", 10^(-4)	
$zeros5=0.00001;			# 10^(-5)
$zeros6=0.000001;			# 10^(-6)

unlink $filenameAnalyzation;
print "\t> removed old $filenameAnalyzation\n";


open (ANALYSE, ">>$filenameAnalyzation") or die "unable to open $filenameAnalyzation: $!\n";

$Datum = localtime(time);
print ANALYSE "generated: $Datum\n\n";

open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
print LOG "running analysis:\n";

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Datenanalyse und Maximiere Anzahl Schueler
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

print "\t> solve for maximum amount of pupils...\n";
print LOG "solve for maximum amount of pupils:\n";
print LOG "perl $filenameRegularScript -x $one -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5\n";
close(LOG);

system("perl $filenameRegularScript -x $one -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5 1>> $filenameLog 2>> $filenameError") == 0 or die "an error has occured with $filenameRegularScript: $!\n";

open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";

#Check, ob der Datensatz loesbar ist, sodass das Skript im Notfall abgebrochen wird
open(TEST,"output/kip_main.txt") or die "unable to open output/kip_main.txt: $!\n";
	$solution_found = 1;
	while(<TEST>) {
		if($_ =~ /^no solution/) {
				$solution_found = 0;
		}
	}
close(TEST);
if($solution_found == 0) {

	print "\nNO SOLUTION AVAILABLE!\ncheck input and output/error.txt for issues!\n";
	print LOG "\nNO SOLUTION AVAILABLE!\ncheck input and output/error.txt for issues!\n";
	print ANALYSE "couldn't find a solution for input data, so the analysis was aborted";
	goto END_OF_SCRIPT; #Abbruch
}

print ANALYSE ("1.) data analysis:\n\n");
open(DETAIL, "$filenameOutput") or die "unable to open $filenameOutput: $!\n";
$print = 0;
while (<DETAIL>) {
	# Geht kip_main-detail solange durch, bis auf "Anmeldungen un..." getroffen wird, dann wird jede folgende Zeile gedruckt
	if($_ =~ /applications of classes with varying sizes:/){
		$print = 1;
	}
	if ($print == 1){
	    print ANALYSE ($_);
	}	
										
}
close(DETAIL);
print ANALYSE "\nwhen maximizing the amount of pupils no classes are matched to those dates (date-ID, course-ID):\n";
open(DETAIL, "$filenameOutput") or die "unable to open $filenameOutput: $!\n";
while (<DETAIL>) {
	if($_ =~ /^\d+/) {
		print ANALYSE $_;
	}
}
close(DETAIL);
print ANALYSE ("\n");

#Infoausgabe
print ANALYSE "2.) result for optimizing amount of pupils:\n";

open(DETAIL, "$filenameOutput") or die "unable to open $filenameOutput: $!\n";
$print = 0;
while (<DETAIL>) {
	$array = $_;		
	if($array =~ /assigned capacity/){
		$print = 1;
	}
	if ($array =~ /------------------------/){
		$print = 0;
	}
	if($array =~ /(amount of new schools that were assigned =) *([0-9.+-eE]*)/){
		$neueSchulen_maxSchueler = int($2);
	}
	if($array =~ /(amount of assigned schools total =) *([0-9.+-eE]*)/){
		$schulen_maxSchueler = int($2);
	}
	if($array =~ /(assigned capacity:.+of) *([0-9.+-eE]*)/){
		$totalKap = int($2);
	}
	if($array =~ /(assigned pupils:) *([0-9.+-eE]*)/){
		$zugSchueler = int($2);
	}
	if ($print == 1){
	    print ANALYSE ($_);
	}	
										
}
close(DETAIL);
print ANALYSE ("\n");

#------------------------------------------------------------------------------
# Gap-Analyse
#------------------------------------------------------------------------------

print "\t> analysing gap..."; # script for gap analysis will do the linebreak
print LOG "gap analysis:\n";
print LOG "perl $filenameGapScript -x $one -y 0 -z 0 -k 0 -t 0\n";
close(LOG);

# script writes to log and console itself
system("perl $filenameGapScript -x $one -y 0 -z 0 -k 0 -t 0 2>> $filenameError") == 0 or die "an error has occured with $filenameGapScript: $!\n";

open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";

open(GAP, "$filenameGap") or die "unable to open $filenameGap: $!\n";
$print = 0;
while (<GAP>) {
	$array = $_;		
	if($array =~ /(capacity that can not be filled =) *([0-9.+-eE]*)/){
		$gap=int($2);
	}
}
close(GAP);
$var1 = $totalKap - $gap;
$var2 = $zugSchueler / $var1 * 100 ;
print ANALYSE ("capacity that can NOT be filled: $gap\n");
print ANALYSE ("capacity that can be filled: $var1\n");
print ANALYSE ("-> assigned capacity that can be filled: $zugSchueler of $var1 = $var2 %\n\n");

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#Maximiere Anzahl Schulen
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
print "\t> solve for maximum amount of schools total...\n";
print LOG "solve for maximum amount of schools total:\n";
print LOG "perl $filenameRegularScript -x $zeros4 -y $zeros5 -z $one -k $zeros6 -t $zeros5\n";
close(LOG);

system("perl $filenameRegularScript -x $zeros4 -y $zeros5 -z $one -k $zeros6 -t $zeros5 1>> $filenameLog 2>> $filenameError") == 0 or die "an error has occured with $filenameRegularScript: $!\n";	

open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";

print ANALYSE "3.) result for optimizing amount of schools total:\n";
open(DETAIL, "$filenameOutput") or die "unable to open $filenameOutput: $!\n";
$print = 0;
while (<DETAIL>) {
	$array = $_;		
	if($array =~ /assigned capacity/){
		$print = 1;
	}
	if ($array =~ /------------------------/){
		$print = 0;
	}
	if($array =~ /(amount of new schools that were assigned =) *([0-9.+-eE]*)/){
		$neueSchulen_maxSchulen = int($2);
	}
	if($array =~ /(amount of assigned schools total =) *([0-9.+-eE]*)/){
		$schulen_maxSchulen = int($2);
	}
	if ($print == 1){
	    print ANALYSE ($_);
	}	
										
}
close(DETAIL);
print ANALYSE ("\n");

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Maximiere Anzahl neue Schulen
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

print "\t> solve for maximum amount of new schools...\n";
print LOG "solve for maximum amount of new schools:\n";
print LOG "perl $filenameRegularScript -x $zeros4 -y $one -z $zeros6 -k $zeros6 -t $zeros5\n";
close(LOG);

system("perl $filenameRegularScript -x $zeros4 -y $one -z $zeros6 -k $zeros6 -t $zeros5 1>> $filenameLog 2>> $filenameError") == 0 or die "an error has occured with $filenameRegularScript: $!\n";	

open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";

print ANALYSE "4.) result for optimizing amount of new schools:\n";
open(DETAIL, "$filenameOutput") or die "unable to open $filenameOutput: $!\n";
$print = 0;
while (<DETAIL>) {
	$array = $_;		
	if($array =~ /assigned capacity/){
		$print = 1;
	}
	if ($array =~ /------------------------/){
		$print = 0;
	}
	if($array =~ /(amount of new schools that were assigned =) *([0-9.+-eE]*)/){
		$neueSchulen_maxNeueSchulen = int($2);
	}
	if($array =~ /(amount of assigned schools total =) *([0-9.+-eE]*)/){
		$schulen_maxNeueSchulen = int($2);
	}
	if ($print == 1){
	    print ANALYSE ($_);
	}	
										
}
close(DETAIL);
print ANALYSE ("\n");

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Maximiere Anzahl Klassen
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
print "\t> solve for maximum amount of assigned classes...\n";
print LOG "solve for maximum amount of assigned classes:\n";
print LOG "perl $filenameRegularScript -x $zeros4 -y $zeros5 -z $zeros6 -k $one -t $zeros5\n";
close(LOG);

system("perl $filenameRegularScript -x $zeros4 -y $zeros5 -z $zeros6 -k $one -t $zeros5 1>> $filenameLog 2>> $filenameError") == 0 or die "an error has occured with $filenameRegularScript: $!\n";	

open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";

print ANALYSE "5.) result for optimizing amount of classes:\n";
open(DETAIL, "$filenameOutput") or die "unable to open $filenameOutput: $!\n";
$print = 0;
while (<DETAIL>) {
	$array = $_;		
	if($array =~ /assigned capacity/){
		$print = 1;
	}
	if ($array =~ /------------------------/){
		$print = 0;
	}
	if($array =~ /(amount of new schools that were assigned =) *([0-9.+-eE]*)/){
		$neueSchulen_maxKlassen = int($2);
	}
	if ($print == 1){
	    print ANALYSE ($_);
	}	
										
}
close(DETAIL);
print ANALYSE ("\n");

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Maximiere Anzahl Termine
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
print "\t> solve for maximum amount of occupied dates...\n";
print LOG "solve for maximum amount of occupied dates:\n";
print LOG "perl $filenameRegularScript -x $zeros4 -y $zeros5 -z $zeros6 -k $zeros6 -t $one\n";
close(LOG);

system("perl $filenameRegularScript -x $zeros4 -y $zeros5 -z $zeros6 -k $zeros6 -t $one 1>> $filenameLog 2>> $filenameError") == 0 or die "an error has occured with $filenameRegularScript: $!\n";	

open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";

print ANALYSE "6.) result for optimizing amount of dates:\n";
open(DETAIL, "$filenameOutput") or die "unable to open $filenameOutput: $!\n";
$print = 0;
while (<DETAIL>) {
	$array = $_;		
	if($array =~ /assigned capacity/){
		$print = 1;
	}
	if ($array =~ /------------------------/){
		$print = 0;
	}
	if($array =~ /(amount of new schools that were assigned =) *([0-9.+-eE]*)/){
		$neueSchulen_maxTermine = int($2);
	}
	if ($print == 1){
	    print ANALYSE ($_);
	}	
										
}
close(DETAIL);
print ANALYSE ("\n");


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#Bikriterielle E-Constraint: maximale Anzahl Schueler vs. maximale Anzahl neuer Schulen
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
print "\t> examine amount of pupils versus new schools; nl = "; # eConstraint script adds line break
print LOG "examine amount of pupils versus new schools:\n";
print LOG "perl $filenameEconstraintScript -x $one -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5 -l $neueSchulen_maxSchueler -u $neueSchulen_maxNeueSchulen\n";
close(LOG);

system("perl $filenameEconstraintScript -x $one -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5 -l $neueSchulen_maxSchueler -u $neueSchulen_maxNeueSchulen 2>> $filenameError") 
    == 0 or die "an error has occured with $filenameEconstraintScript: $!\n";	 

open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";

print ANALYSE "7.) analysis for maximum amount of pupils vs amount of new schools:\n\n";
open(ECONST, "$filenameEconstraint") or die "unable to open $filenameEconstraint: $!\n";
while (<ECONST>) {
	if($_ =~ /^\d+/) {
		print ANALYSE $_;
	}
}
close(ECONST);
print ANALYSE ("\n\n");

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#Bikriterielle E-Constraint: maximale Anzahl Schueler vs. maximale Anzahl Schulen insgesamt
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
print "\t> examine amount of pupils versus schools total; l = "; # eConstraint2 script adds line break
print LOG "examine amount of pupils versus schools total:\n";
print LOG "perl $filenameEconstraintScript2 -x $one -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5 -l $schulen_maxSchueler -u $schulen_maxSchulen\n";
close(LOG);

system("perl $filenameEconstraintScript2 -x $one -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5 -l $schulen_maxSchueler -u $schulen_maxSchulen 2>> $filenameError") 
    == 0 or die "an error has occured with $filenameEconstraintScript2: $!\n";

print ANALYSE "8.) analysis for maximum amount of pupils vs amount of schools total:\n\n";
open(ECONST2, "$filenameEconstraint2") or die "unable to open $filenameEconstraint2: $!\n";
while (<ECONST2>) {
	if($_ =~ /^\d+/) {
		print ANALYSE $_;
	}
}
close(ECONST2);
print ANALYSE ("\n\n");

END_OF_SCRIPT: #Sprungmarke zum Abbrechen
close(ANALYSE);
