#Ueberpruefung, ob das Erhöhen der Kapazitaet eines Termins zu einer groesseren Anzahl Schueler fuehrt
# Parameter: x,y,z,k,t sind die Gewichtungsfaktoren, m ist die minimale Kapazitaetserhoehung, c die maximale und o nimmt einen einzelnen Termin zur Betrachtung entgegen

#Initialisieren der Default-Werte
$lambda0 = 1;									#Gewichtungsfaktor fuer erste Zielfunktion (Schueler)
$lambda1 = 0.00001;								#Gewichtungsfaktor fuer zweite Zielfunktion (neue Schulen)
$lambda2 = 0.000001;								#Gewichtungsfaktor fuer dritte Zielfunktion (Schulen)
$lambda3 = 0.000001;								#Gewichtungsfaktor fuer dritte Zielfunktion (Klassen)
$lambda4 = 0.00001;								#Gewichtungsfaktor fuer dritte Zielfunktion (Termine)

$minKap = 1;									#minimale Kapazitaetserhoehung
$maxKap = 3;									#Groesse der maximalen Kapazitaetserhoehung

use Getopt::Std;								#Uebergabeparameter parsen
$myoptString = "'x:y:z:k:t:m:c:o:l'";
%options = ();
getopts("$myoptString", \%options);
$lambda0 = $options{x} if defined $options{x};
$lambda1 = $options{y} if defined $options{y};
$lambda2 = $options{z} if defined $options{z};
$lambda3 = $options{k} if defined $options{k};
$lambda4 = $options{t} if defined $options{t};
$minKap = $options{m} if defined $options{m};
$maxKap = $options{c} if defined $options{c};
$einzelTermin = $options{o} if defined $options{o};

$capIncreaseLoc = "input/capIncrease.txt";
$capIncreaseTempLoc = "input/capIncrease_temp.txt";
$logLoc = "output/kip_capacityIncrement.txt";
$mainInputLoc = "input/main.txt";
$capIncCandLoc = "capIncreaseCandidates.txt";
$filenameLog = "output/log.txt";

my @termin_ids = ();
my $AnzahlSchueler = 0;			#Anzahl der Schueler mit Kapazitaeten des Inputs
my $AnzahlSchuelerPlus = 0;		#Anzahl der Schueler nach Erhoehung der Kapazitaet eines Termins
my %termin_name = ();			#Zuordnung Termin-ID - Bezeichnung
my %termin_kurs = ();           #Zuordnung Termin-ID - Kurs-ID

$filenameLog="output/log.txt";

$ZIMPL = "";
$SCIP = "";
if($^O eq 'MSWin32'){

    $ZIMPL = "Start /B /W win_binary/zimpl.exe";
    $SCIP = "Start /B /W win_binary/scip.exe";

}
elsif($^O eq 'linux'){
    
    $ZIMPL = "zimpl";
    $SCIP = "scip";
    
}
else {

    die "Unknown operating system!\n";
    
}

open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
print LOG "perl scripts/kip_main.pl $lambda0 $lambda1 $lambda2 $lambda3 $lambda4\n";
close(LOG);
system("perl scripts/kip_main.pl $lambda0 $lambda1 $lambda2 $lambda3 $lambda4 1>> $filenameLog") == 0 or die "an error occured with scripts/kip_main.pl: $!\n";	#Output von kip_main wird benoetigt

unlink $logLoc;					#Loeschen von Daten von eventuellen vorherigen Berechnungen

#$AnzahlSchueler bestimmen
open(FILE,"output/kip_main.txt") or die "unable to open output/kip_main.txt: $!\n";
while(<FILE>) {

	if($_ =~ /^xsum/) {
	
		@array_FILE = split " ",$_;
		$AnzahlSchueler = int($array_FILE[1]);
	
	}

}
close(FILE);

if($options{l}) { # gegebene Kandidatenliste

    use File::Copy qw(copy);
    unlink "capIncreaseSuggestion.txt";
    
    my @candidates_ids = ();
    my %candidates_maxCapInc = ();
    
    # alle termine finden
	open(INPUT,$mainInputLoc) or die "unable to open $mainInputLoc: $!\n";
	while(<INPUT>) {
	
        chomp();
		@array_INPUT = split " ",$_;
		if($array_INPUT[0] eq "t") {
		
            push(@termin_ids, $array_INPUT[1]);
			$termin_name{$array_INPUT[1]} = $array_INPUT[6];
			$termin_kurs{$array_INPUT[1]} = $array_INPUT[2];
		}
	
	}
	close(INPUT);
			    
    # Kandidaten finden und prüfen
    open(INPUT,$capIncCandLoc) or die "unable to open $capIncCandLoc: $!\n";
	while(<INPUT>) {
	
        chomp();
		@array_INPUT = split " ",$_;
		if($array_INPUT[0] eq "t") {
		
		    $isDate = 0;
		    $name = "";
		    foreach $ID (@termin_ids) {
		        if($ID eq $array_INPUT[1]) {
				    $isDate = 1;
				    $name = $termin_name{$ID};
				    last;
				}
			}
			if($isDate == 1)
			{
		        $thisDateID = $array_INPUT[1];
		        push(@candidates_ids, $thisDateID);
		        $candidates_maxCapInc{$thisDateID} = $array_INPUT[2];
		        
	        }
	        else {
	            
	            die "unknown date ID: $array_INPUT[1] in $capIncCandLoc!\n";
	        
	        }
	    }
    }
    close(INPUT);

    # derzeitiges capIncrease.txt laden und sichern
    copy $capIncreaseLoc, $capIncreaseTempLoc;
    open(INPUT,$capIncreaseLoc) or die "unable to open $capIncreaseLoc!\n";
    @capIncreaseCurrentContent = <INPUT>;
    %increasedDates = (); # weise Termin derzeitige Kapazitaetserhoehung zu
    %datesLine = (); # Zeilen-Index der Termine
    for my $i (0 .. $#capIncreaseCurrentContent){

        $line = $capIncreaseCurrentContent[$i];
        chomp($line);
        @array_line = split " ",$line;
        if($array_line[0] eq "t"){

            $isDate = 0;
            foreach $ID (@termin_ids) {
                if($ID eq $array_line[1]) {
		            $isDate = 1;
		            last;
		        }
	        }
	        if($isDate == 1)
	        {
                $increasedDates{$array_line[1]} = $array_line[2];
                $datesLine{$array_line[1]} = $i;       
            }
            else {
                
                die "unknown date ID $array_line[1] in $capIncreaseLoc!\n";
            }
        }
    }
    close(INPUT);

    # Kapazitaetsanalyse
    open(OUTPUT, ">>$logLoc") or die "couldn't create or open $logLoc: $!\n";
    $Datum = localtime(time);
    print OUTPUT "generated: $Datum\n\n";

    print OUTPUT "Total amount of pupils prior to any increase of capacity: $AnzahlSchueler\n";

    $numberOfdates = @candidates_ids; # number of dates
    $dateCounter = 0;
    $printedProgress25 = 0;
    $printedProgress50 = 0;
    $printedProgress75 = 0;

    foreach $termin (@candidates_ids){

        $dateCounter++;
        $examinedPerc = $dateCounter/$numberOfdates;
        if($examinedPerc >= 0.25 and $printedProgress25 == 0) {
            print "25\%...";
            $printedProgress25 = 1;
        }
        elsif($examinedPerc >= 0.5 and $printedProgress50 == 0) {
            print "50\%...";
            $printedProgress50 = 1;
        }
        elsif($examinedPerc >= 0.75 and $printedProgress75 == 0) {
            print "75\%...";
            $printedProgress75 = 1;
        }
        
        my @diffs = ();
        for(my $inc = 1; $inc <= $candidates_maxCapInc{$termin}; $inc++){

            $Quot = 0;
            $Diff = 0;

            #zpl-file generieren
            open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		    print LOG "examine capacity increase by $inc for date $termin:\n";
		    print LOG "perl scripts/zimplmodel.pl $lambda0 $lambda1 $lambda2 $lambda3 $lambda4 kip_capacityIncrement $inc $termin\n";
		    close(LOG);
		    
            system("perl scripts/zimplmodel.pl $lambda0 $lambda1 $lambda2 $lambda3 $lambda4 kip_capacityIncrement $inc $termin 1>> $filenameLog") == 0 or die "failed to generate zimpl-file: $!\n";

            #ZIMPL starten
            open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		    print LOG "$ZIMPL -o output/zimpl/kip_capacityIncrement output/zimpl/kip_capacityIncrement.zpl\n";
		    close(LOG);
            
            system("$ZIMPL -o output/zimpl/kip_capacityIncrement output/zimpl/kip_capacityIncrement.zpl 1>> $filenameLog") == 0 or die "failed to create lp-file with ZIMPL: $!\n";
                
            #SCIP starten
            open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		    print LOG "$SCIP -b scripts/scip/kip_capI.bat\n";
		    close(LOG);
		    
            system("$SCIP -b scripts/scip/kip_capI.bat 1>> $filenameLog") == 0 or die "an error occured with SCIP: $!\n";

            #Anzahl Schueler nach Kapazitaetserhoehung einlesen
            open(TMP, 'output/temporary/kip_capacityIncrement-tmp.txt') or die "unable to open kip_capacityIncrement-tmp.txt: $!\n";
            while(<TMP>){

	            if($_ =~ /^xsum/) {

		            @array_TMP = split " ",$_;
		            $AnzahlSchuelerPlus = int($array_TMP[1]);

	            }

            }
            close(TMP);

            #Output schreiben
            $Diff = $AnzahlSchuelerPlus - $AnzahlSchueler;
            $Quot = $Diff/$inc;

            $Name = $termin_name{$termin};
	        $kurs = $termin_kurs{$termin};
            print OUTPUT "\nIncreasing capacity by $inc for date $termin, course $kurs ($Name)\n";
            if ($Quot > 0) {

	            printf OUTPUT "-> $Diff additional pupils ($AnzahlSchuelerPlus total) [%5.2f pupils per increase by 1]\n", $Quot;
	            push(@diffs, $Diff);

            }
            else {

	            print OUTPUT "-> doesn't affect the optimal result!\n";
	            push(@diffs, 0);
            }
        }

        #finde beste Erhoehung
        $increaseCapBy = 0;
        $bestDiff = 0;
        for my $i(0 .. $#diffs){

            if($diffs[$i] > $bestDiff){
            
                $bestDiff = $diffs[$i];
                $increaseCapBy = $i + 1;
            }
        }
        #da diffs nach Kapazitaetserhoehung sortiert ist erhaelt man so die beste Erhoehung mit wiederum bestem Quotienten Diff/inc
        #fuehre Kapazitaetserhoehung durch
        if($increaseCapBy > 0){

            print OUTPUT "\nincreased capacity of $termin, ";
            $AnzahlSchueler += $bestDiff; # derzeit beste Anzahl Schueler nach Erhoehung
            print OUTPUT "continuing analysis with base amount of pupils of $AnzahlSchueler\n";
            if(exists($increasedDates{$termin})){
            
                $increasedDates{$termin} += $increaseCapBy;
                $capIncreaseCurrentContent[$datesLine{$termin}] = "t\t$termin\t$increasedDates{$termin}\n";
            }
            else{
            
                $increasedDates{$termin} = $increaseCapBy;
                $newline = "t\t$termin\t$increaseCapBy\n";
                push(@capIncreaseCurrentContent, $newline);
                $datesLine{$termin} = $#capIncreaseCurrentContent;
            }
            #replace capIncrease.txt
            open(CAPINC,">$capIncreaseLoc") or die "unable to open $capIncreaseLoc!\n";
            foreach $line (@capIncreaseCurrentContent){ print CAPINC $line; }
            close(CAPINC);
        }
    }
    print "done\n";
    close(OUTPUT);

    # restore capIncrease.txt original content
    unlink $capIncreaseLoc;
    copy $capIncreaseTempLoc, $capIncreaseLoc;
    unlink $capIncreaseTempLoc;
    # write new capIncrease
    open(NEWCAPINC,">capIncreaseSuggestion.txt") or die "unable to create capIncreaseSuggestion.txt!\n";
    print NEWCAPINC "ct	dateID	increase";
    foreach $line (@capIncreaseCurrentContent){ print NEWCAPINC $line; }
    close(NEWCAPINC);
}
else {

    #Terminliste anlegen
    if($einzelTermin ne "") {

	
	    push(@termin_ids, $einzelTermin);
	    open(INPUT,$mainInputLoc) or die "unable to open $mainInputLoc: $!\n";
	    while(<INPUT>){
	
		    @array_INPUT = split " ",$_;
		    if($array_INPUT[0] eq "t" && $array_INPUT[1] eq $einzelTermin) {
		
			    $termin_name{$einzelTermin} = $array_INPUT[6];
			    $termin_kurs{$einzelTermin} = $array_INPUT[2];
		
		    }
	
	    }
	    close(INPUT);

    }
    else {
		
	    open(INPUT,$mainInputLoc) or die "unable to open $mainInputLoc: $!\n";
	    while(<INPUT>) {
	
		    chomp();
		    @array_INPUT = split " ",$_;
		    if($array_INPUT[0] eq "t") {
		
                push(@termin_ids, $array_INPUT[1]);
			    $termin_name{$array_INPUT[1]} = $array_INPUT[6];
			    $termin_kurs{$array_INPUT[1]} = $array_INPUT[2];
			
		    }
	
	    }
	    close(INPUT);
    }

    $j = 0; #relevant um zu bestimmen, ob eine bestimmte Zeile in den Output geschrieben werden soll

    open(OUTPUT, ">>$logLoc") or die "couldn't create or open $logLoc: $!\n";
    $Datum = localtime(time);
    print OUTPUT "generated: $Datum\n\n";

    print OUTPUT "Total amount of pupils prior to any increase of capacity: $AnzahlSchueler\n";
    
    #fuer jeden in Frage kommenden Termin die Kapazitaet um minKap,...,maxKap erhoehen
    $numberOfdates = @termin_ids; # number of dates
    for ($i = $minKap; $i <= $maxKap; $i++) {

	    if($einzelTermin eq "") { print "\t> $i..."; }
	    $dateCounter = 0;
        $printedProgress25 = 0;
        $printedProgress50 = 0;
        $printedProgress75 = 0;
    
	    foreach $termin (@termin_ids) {
	
		    if($einzelTermin eq "") {
		        $dateCounter++;
		        $examinedPerc = $dateCounter/$numberOfdates;
                if($examinedPerc >= 0.25 and $printedProgress25 == 0) {
                    print "25\%...";
                    $printedProgress25 = 1;
                }
                elsif($examinedPerc >= 0.5 and $printedProgress50 == 0) {
                    print "50\%...";
                    $printedProgress50 = 1;
                }
                elsif($examinedPerc >= 0.75 and $printedProgress75 == 0) {
                    print "75\%...";
                    $printedProgress75 = 1;
                }
            }
		    
		    $Quot = 0;
		    $Diff = 0;
		
		    #zpl-file generieren
		    open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		    print LOG "examine capacity increase by $i for date $termin:\n";
		    print LOG "perl scripts/zimplmodel.pl $lambda0 $lambda1 $lambda2 $lambda3 $lambda4 kip_capacityIncrement $i $termin\n";
		    close(LOG);
		    
		    system("perl scripts/zimplmodel.pl $lambda0 $lambda1 $lambda2 $lambda3 $lambda4 kip_capacityIncrement $i $termin 1>> $filenameLog") == 0 or die "failed to generate zimpl-file: $!\n";
		
		    #ZIMPL starten
		    open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		    print LOG "$ZIMPL -o output/zimpl/kip_capacityIncrement output/zimpl/kip_capacityIncrement.zpl\n";
		    close(LOG);
		    
		    system("$ZIMPL -o output/zimpl/kip_capacityIncrement output/zimpl/kip_capacityIncrement.zpl 1>> $filenameLog") == 0 or die "failed to create lp-file with ZIMPL: $!\n";
		        
		    #SCIP starten
		    open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		    print LOG "$SCIP -b scripts/scip/kip_capI.bat\n";
		    close(LOG);
		    
		    system("$SCIP -b scripts/scip/kip_capI.bat 1>> $filenameLog") == 0 or die "an error occured with SCIP: $!\n";
		
		    #Anzahl Schueler nach Kapazitaetserhoehung einlesen
		    open(TMP, 'output/temporary/kip_capacityIncrement-tmp.txt') or die "failed to open kip_capacityIncrement-tmp.txt: $!\n";
		    while(<TMP>){
		
			    if($_ =~ /^xsum/) {
	
				    @array_TMP = split " ",$_;
				    $AnzahlSchuelerPlus = int($array_TMP[1]);
	
			    }
		
		    }
		    close(TMP);
		
		    #Output schreiben
		    $Diff = $AnzahlSchuelerPlus - $AnzahlSchueler;
		    $Quot = $Diff/$i;
		
		    print OUTPUT "\nIncreasing capacity by $i for date...\n" if $j == 0;
		    if ($Quot > 0) {
		
			    $Name = $termin_name{$termin};
			    $kurs = $termin_kurs{$termin};
			    printf OUTPUT "t\t%4d\t$i\t, course %4d ($Name) -> %4d additional pupils (%4d total) [%5.2f pupils per increase by 1]", $termin, $kurs, $Diff, $AnzahlSchuelerPlus, $Quot;
			    print OUTPUT "\n";
		
		    }
		    elsif($Quot == 0 && scalar @termin_ids == 1) {
		
			    print OUTPUT "... $termin doesn't affect the optimal result!\n"; #sollte ein einzeln betrachteter Termin keine Veraenderung bringen
		
		    }
		
		    $j++;
	    }
	
	    $j = 0;
	    if($einzelTermin eq "") { print "done\n"; }
    }

    close(OUTPUT);
}
