#GAP-Rechnung bezueglich der theoretisch maximalen Auslastung
#Single Knapsack Problem fur jeden Termin j bei den Basis-Kapazitaeten ohne Erhoehung- 
# = "Nicht-nutzbare Kapazitaet"

# usage: perl kip_gapAnalyzation [-x lambda0] [-y lambda1] [-z lambda2] [-k lambda3] [-t lambda4]

# flush output
$| = 1;

#Initialisieren der Default-Werte
$lambda0 = 1;									#Gewichtungsfaktor fuer erste Zielfunktion (Schueler)
$lambda1 = 0;								#Gewichtungsfaktor fuer zweite Zielfunktion (neue Schulen)
$lambda2 = 0;								#Gewichtungsfaktor fuer dritte Zielfunktion (Schulen)
$lambda3 = 0;								#Gewichtungsfaktor fuer dritte Zielfunktion (Klassen)
$lambda4 = 0;								#Gewichtungsfaktor fuer dritte Zielfunktion (Termine)

use Getopt::Std;								#Uebergabeparameter parsen
$myoptString = "'x:y:z:k:t:'";
%options = ();
getopts("$myoptString", \%options);
$lambda0 = $options{x} if defined $options{x};
$lambda1 = $options{y} if defined $options{y};
$lambda2 = $options{z} if defined $options{z};
$lambda3 = $options{k} if defined $options{k};
$lambda4 = $options{t} if defined $options{t};

$filenameLog="output/log.txt";

$ZIMPL = "";
$SCIP = "";
if($^O eq 'MSWin32'){

    $ZIMPL = "Start /B /W win_binary/zimpl.exe";
    $SCIP = "Start /B /W win_binary/scip.exe";

}
elsif($^O eq 'linux'){
    
    $ZIMPL = "zimpl";
    $SCIP = "scip";
    
}
else {

    die "Unknown operating system!\n";
    
}

open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
print LOG "perl scripts/kip_main.pl $lambda0 $lambda1 $lambda2 $lambda3 $lambda4\n";
close(LOG);
#STDERR is already being piped to the error log
system("perl scripts/kip_main.pl $lambda0 $lambda1 $lambda2 $lambda3 $lambda4 1>> $filenameLog") == 0 or die "an error occured with scripts/kip_main.pl: $!\n";
	$valueSum =0;
unlink "output/kip_gapAnalyzation.txt";					#Loeschen von Daten von eventuellen vorherigen Berechnungen

open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";

open(OUTFILE, ">>output/kip_gapAnalyzation.txt") or die "unable to open output/kip_gapAnalyzation.txt: $!\n";
$Datum = localtime(time);
print OUTFILE "generated: $Datum\n\n";
print OUTFILE "date-ID with capacity that can't be filled:\n";
close(OUTFILE);

#==========================================================================
#Betrachtung aller Termine
#==========================================================================

print LOG "-"x76,"\ngap analysis:\n","-"x76,"\n" ;

#Einlesen der Termine
open(OUTFILE2, 'input/main.txt') or die "unable to open input/main.txt: $!\n";	
while (<OUTFILE2>) {
	chomp();
	($u, $b, $c, $d, $e, $ff) = split(/\t/, $_);
	if($u eq "t"){
		$kap{$b} = "$d";  						#%kap: termin_id --> Kapazitaet eines Termins
		$sum_kap += $d;							#Gesamtkapazitaet	
		$zaehler_termine++;	
		push(@termin_ids,$b);
	}
}
close(OUTFILE2);

open(OUTFILE4, 'input/capIncrease.txt') or die "$0: unable to open input/capIncrease.txt: $!\n";			# beachte kaperhoehung
	while (<OUTFILE4>) {
	chomp();
	($u2, $b2, $c2) = split(/\t/,$_);
	if( $u2 eq "t" ){		  					
			$sum_kap = $sum_kap + $c2;				#Gesamtkapazitaet	
			$kap{$b2} += $c2;
		} 
}
close(OUTFILE4);
$g2 = 0;
$k = 0; # counter für Termin
$numberOfdates = @termin_ids; # number of dates
$printedProgress25 = 0;
$printedProgress50 = 0;
$printedProgress75 = 0;

#Berechnung der maximal moeglichen Auslastung fuer jeden einzelnen Termin
foreach $i (@termin_ids){

    $k++;
    $examinedPerc = $k/$numberOfdates;
    if($examinedPerc >= 0.25 and $printedProgress25 == 0) {
        print "25\%...";
        $printedProgress25 = 1;
    }
    elsif($examinedPerc >= 0.5 and $printedProgress50 == 0) {
        print "50\%...";
        $printedProgress50 = 1;
    }
    elsif($examinedPerc >= 0.75 and $printedProgress75 == 0) {
        print "75\%...";
        $printedProgress75 = 1;
    }

	print LOG "calculating gap for date $i ($k of ", scalar(@termin_ids), "):\n";

	#Erstellung des ZIMPL-Models
	print LOG "perl scripts/zimplmodel.pl $lambda0 $lambda1 $lambda2 $lambda3 $lambda4 kip_gapAnalyzation $i\n";
	close(LOG);
	system("perl scripts/zimplmodel.pl $lambda0 $lambda1 $lambda2 $lambda3 $lambda4 kip_gapAnalyzation $i 1>> $filenameLog") == 0 or die "\nan error occured with scripts/zimplmodel.pl: $!\n";
	open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
	
	#Ausfuehrung von ZIMPL
    print LOG "$ZIMPL -o output/zimpl/kip_gapAnalyzation output/zimpl/kip_gapAnalyzation.zpl\n";
	close(LOG);
	system("$ZIMPL -o output/zimpl/kip_gapAnalyzation output/zimpl/kip_gapAnalyzation.zpl 1>> $filenameLog") == 0 or die "\nfailed to create lp file for date ID $i with ZIMPL: $!\n"; 
    open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";

	#Ausfuehrung von SCIP
    print LOG "$SCIP -b scripts/scip/kip_gapA.bat\n";
	close(LOG);
	system("$SCIP -b scripts/scip/kip_gapA.bat 1>> $filenameLog") == 0 or die "\nan error occured with SCIP $!\n";
	open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";

	#==========================================================================
	#Ausgabe der Loesung
	#==========================================================================
	$termId = $i;                                               # Termin-Id
	$array = "";
	$g = 0;	                                                    # S-gap
	$value=0;
	%t = ();
	
	open(OUTFILE, ">>output/kip_gapAnalyzation.txt") or die "\nunable to open output/kip_gapAnalyzation.txt: $!\n";	

	#Einlesen der SCIP-Loesung
	open(FILETMP, 'output/temporary/kip_gapAnalyzation-tmp.txt') or die "\nunable to open output/temporary/kip_gapAnalyzation-tmp.txt: $!\n";
	while (<FILETMP>) {
		$array = $_;
		
		if($array =~ /(objective value:) *([0-9.+-eE]*)/){
			$value = int($2 + 0.00005);
		}
		
		$zeile[$i2] = $_;						
		@aktuelle_zeile = split("#", $zeile[$i2]);											
	}
	close(FILETMP);

	$g = $kap{$termId} - $value;						#TerminkapazitÃ¤t abzÃ¼glich der Anzahl zugeordneter SchÃ¼ler
	$g2 += $g;                                       # Gesamtgap
	$ergebnis{$termId} = "$g";						#"ergebnis": Termin --> S-gap
	
	@dat = sort keys %ergebnis;	
	$numb = @dat;
	foreach $x (@dat){
		print OUTFILE "$x,$ergebnis{$x}\n" if $ergebnis{$x} > 0;   		#Termin,  S-gap
	}

	close(OUTFILE);
	delete $ergebnis{$termId};						#ausgelesenen Eintrag wieder aus dem Hash entfernen

	print LOG "=> gap: $kap{$termId} - $value = $g\n";

}

print "done\n";

open(ANA, ">>output/kip_gapAnalyzation.txt") or die "$0: unable to open file output/kip_gapAnalyzation.txt: $!\n";
print ANA "capacity that can not be filled = $g2\n";				#Summe: GAP ueber aller Termine
close(ANA) or die "$0: unable to close file output/kip_gapAnalyzation.zpl: $!\n";

close(LOG);

