# Bei Aenderungen bitte print-Befehl in Zeile 10 anpassen!
use strict;

# Skript zur einfacheren Interaktion mit kunikip über die Kommandozeile

my $zeros4=0.0001;	
my $zeros5=0.00001;
my $zeros6=0.000001;

my $filenameError="output/error.txt";
my $filenameLog="output/log.txt";

#Begruessung
print "\n","-"x76,"\nstarting KUniKIP 1.4 [last changed September 2017]\n","-"x76,"\n";
if($^O eq 'MSWin32'){
    
    print "Windows operating system detected\n";
    
}    
elsif($^O eq 'linux'){
    
    print "Linux operating system detected\n";
    
}
else {

    die "unknown operating system!\n";
    
}

unlink $filenameError;
unlink $filenameLog;
print "cleared logs...\n";

open (LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
my $Datum = localtime(time);
print LOG "generated: $Datum\n\n";


#static.txt ist eine arge Fehlerquelle und muss auf Korrektheit überprüft werden
my $checkedStatic = 0; #flowcontrol

CHECK_STATIC: #Sprungmarke

if($checkedStatic == 1){

	print "\nadjust static.txt then press ENTER to proceed\n";
	my $leer = <STDIN>;

}

print "verify validity of input/static.txt...";
$checkedStatic = 1;
open(TOCHECK,"input/static.txt") or die "unable to open input/static.txt: $!\n";
my $prevK = ""; 	#vorherige Klassen-ID (zum Abgleich, ob eine Klassen-ID mehrfach vorkommt)
my $founderror = 0;
while(<TOCHECK>){

	chomp();
	(my $z, my $t, my $k) = split(/\t/,$_);
	if($z eq "z"){
	
	    my $size;
	    my $kapa;
	    my $kapto;
	    my $mingrade;
	    my $maxgrade;
	    my $grade;
		
		#doppelte Klassen-IDs rausfiltern
		if ($k eq $prevK){
		
			print "static.txt contains the class-ID $k twice which is forbidden!\n";
			$founderror = 1;
		
		}
		$prevK = $k;
		
		#Kapazitaeten, Altersstufen und Anmeldungen ueberpruefen
		my @Applications = ();
		#Input einlesen
		open(INPUT,"input/main.txt") or die "unable to open input/main.txt: $!\n";
		while(<INPUT>){
		
			chomp();
			(my $u, my $b, my $c, my $d, my $e, my $f) = split(/\t/,$_);
			if ($u eq "a" && $c eq $k){
			
				$size = $e;
				push(@Applications,$d); #Termine, fuer die sich die Klasse angemeldet hat
			
			}
			if ($u eq "t" && $b eq $t){
			
				$kapa = $d;
				$mingrade = $e;
				$maxgrade = $f;
			
			}
			if ($u eq "k" && $b eq $k) {
			
				$grade = $e;
			
			}
		
		}
		close(INPUT);
		$kapto = 0;
		open(INPUT2,"input/capIncrease.txt") or die "unable to open input/kapErhoehung.txt: $!\n";
		while(<INPUT2>){
		
			(my $q, my $w, my $v) = split(/\t/,$_);
			if($q eq "t" && $w eq $t){
			
				$kapto = $v;
			
			}
			
		}
		close(INPUT2);
		my $kapa_kapto = $kapa + $kapto;
		#Kapazitaeten
		if($size > $kapa_kapto){
		
			print "Size of class $k is larger than the capacity of date $t!\n";
			$founderror = 1;
		
		}
		#Altersstufen
		if($mingrade > $grade or $maxgrade < $grade) {
		
			print "Class $k has the wrong grade for date $t!\n";
			$founderror = 1;
		
		}
		#Anmeldungen
		my $appliedforTerm = 0;
		foreach my $term (@Applications){
		
			if($term eq $t){
			
				$appliedforTerm = 1;
			
			}
		
		}
		if($appliedforTerm == 0){
		
			print "Class $k didn't apply for date $t!\n";
			$founderror = 1;
		
		}
	}
}
close(TOCHECK);

if($founderror == 1){

	goto CHECK_STATIC;

}

print LOG "verified validity of input/static.txt\n";
print " verified\n";

# filter out duplicate applications
my $checkedMain = 0;
my %classesToAppIDs; # maps class ID to an array reference containing date and application IDs

CHECK_MAIN: #Sprungmarke

if($checkedMain == 1){

	print "\n\nremove duplicates in main.txt and press ENTER to proceed\n";
	my $leer = <STDIN>;

}

print "verify validity of input/main.txt...";
$checkedMain = 1;
open(INPUT,"input/main.txt") or die "unable to open input/main.txt: $!\n";
$founderror = 0;
%classesToAppIDs = (); 
while(<INPUT>){

	chomp();
	(my $identifier, my $appID, my $classID, my $dateID, my $size) = split(/\t/,$_);
	
	if( $identifier eq "a" )
	{
	    if( exists $classesToAppIDs{$classID} )
	    {
	        my $datesAndAppIDsRef = $classesToAppIDs{$classID};
	        for(my $i = 0; $i < scalar @$datesAndAppIDsRef; $i = $i + 2)
	        {
	            if( $dateID eq $$datesAndAppIDsRef[$i] )
	            {
	                my $otherAppID = $$datesAndAppIDsRef[$i + 1];
	                print "\nduplicate application found: class $classID applied to date $dateID with applications $otherAppID and $appID!";
	                $founderror = 1;
	                last;
	            }
	        }
	        
	        push(@$datesAndAppIDsRef, $dateID, $appID);
	    }
	    else
	    {
	        my @datesAndAppIDs = ($dateID, $appID);
	        $classesToAppIDs{$classID} = \@datesAndAppIDs;
	    }
	    
	}
}
close(INPUT);

if($founderror == 1){

	goto CHECK_MAIN;

}
print LOG "verified validity of input/main.txt\n";
print " verified\n\nexpecting command (show help with 'h'):\n";
close(LOG); #force flush

my $Eingabe;

START: #Sprungmarke

while(1){

#Eingabeaufforderung
    open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
    
	print "\nKUniKIP>";
	$Eingabe = <STDIN>;
	chomp $Eingabe;
	
	print "\n";
	
#kunikip beenden
	if($Eingabe eq "quit" or $Eingabe eq "q" or $Eingabe eq "exit")	{
		
		print "-"x76,"\n";
		print LOG "\n","-"x76,"\nquit\n","-"x76,"\n";
		close(LOG);
		last; # termination
		
	}
	
#Hilfe anzeigen
	elsif($Eingabe eq "h")	{
	
		print "-"x76,"\n","known commands:\n\n";
		print " h"," "x10,"shows this help\n";
		print " a"," "x10,"generates analysis.txt\n";
		print " o"," "x10,"solves the problem and generates data base upload\n";
		print " g"," "x10,"calculates capacity that can't be filled up (gap)\n";
		print " l"," "x10,"compares amounts of schools to maximum amount of pupils\n";
		print " nl"," "x9,"compares amounts of new schools to maximum amount of pupils\n";
		print " c"," "x10,"analyzes the effect of increasing the capacity for certain dates\n";
		print " q"," "x10,"quits KUniKIP (as do \"quit\" and \"exit\")\n";
		print "\n","-"x76,"\n";
	
	}
	
#Erstelle analysis.txt (rufe kunikip.pl auf)	
	elsif($Eingabe eq "a")	{
	
		print "-"x76,"\nanalysing input...\n";
		print LOG "perl kunikip.pl\n";
		close(LOG);
		
		system("perl kunikip.pl") == 0 or die "an error has occured with kunikip.pl: $!\n";
		
		open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		
		print "-"x76,"\n";
		print "analysis result is located in analysis.txt\n";
		print "-"x76,"\n";
		
	    print LOG "-"x76,"\n";
		print LOG "analysis result is located in analysis.txt\n";
		print LOG "-"x76,"\n";
	
	    close(LOG); # force flush
	}
	
#Starte einen Optimierungsdurchlauf	
	elsif($Eingabe eq "o")	{
	
		my $minS = 0;
		my $minNSL = 0;
		my $minSL = 0;
		my $minK = 0;
		my $minT = 0;
		my $startkip = 0;
		my $Modus;
		my $x;
		my $y;
		my $z;
		my $k;
		my $t;
		my $ziel;
		my $minBool;
		
		print "-"x76,"\nChoose the optimization target:\n\ns   for amount of pupils\nsl  for amount of schools\nnsl for amount of new schools\nk   for amount of classes\nt   for amount of dates\n";
		GET_MODUS: #Sprungmarke
		print "\nKUniKIP|o>";
		$Modus = <STDIN>;
		chomp $Modus;
		
		if($Modus eq "s")	{
		
			print "\ndefine minimum parameter? (y=yes)\n\nKUniKIP|o|$Modus>";
			$minBool = <STDIN>;
			chomp $minBool;
			if ($minBool eq "y") {
			
				print "\nminimum parameter [Default = 0]:\n";
				print "min. amount of new schools: ";
				$minNSL = int(<STDIN>);
				print "min. amount of schools total: ";
				$minSL = int(<STDIN>);
				print "min. amount of classes: ";
				$minK = int(<STDIN>);
				print "min. amount of dates: ";
				$minT = int(<STDIN>);
				
			}
			$x = 1;
			$y = $zeros5;
			$z = $zeros6;
			$k = $zeros6;
			$t = $zeros5;
			$ziel = "pupils";
		
		}
		elsif($Modus eq "sl")	{
		
			print "\ndefine minimum parameter? (y=yes)\n\nKUniKIP|o|$Modus>";
			$minBool = <STDIN>;
			chomp $minBool;
			if ($minBool eq "y") {
			
				print "\nminimum parameter [Default = 0]:\n";
				print "min. amount of pupils : ";
				$minS = int(<STDIN>);
				print "min. amount of new schools: ";
				$minNSL = int(<STDIN>);
				print "min. amount of classes: ";
				$minK = int(<STDIN>);
				print "min. amount of dates: ";
				$minT = int(<STDIN>);
				
			}
			$x = $zeros4;
			$y = $zeros5;
			$z = 1;
			$k = $zeros6;
			$t = $zeros5;
			$ziel = "schools total";
		
		}
		elsif($Modus eq "nsl")	{
		
			print "\ndefine minimum parameter? (y=yes)\n\nKUniKIP|o|$Modus>";
			$minBool = <STDIN>;
			chomp $minBool;
			if ($minBool eq "y") {
			
				print "\nminimum parameter [Default = 0]:\n";
				print "min. amount of pupils: ";
				$minS = int(<STDIN>);
				print "min. amount of schools total: ";
				$minSL = int(<STDIN>);
				print "min. amount of classes: ";
				$minK = int(<STDIN>);
				print "min. amount of dates: ";
				$minT = int(<STDIN>);
				
			}
			$x = $zeros4;
			$y = 1;
			$z = $zeros6;
			$k = $zeros6;
			$t = $zeros5;
			$ziel = "new schools";
		
		}
		elsif($Modus eq "k")	{
		
			print "\ndefine minimum parameter? (y=yes)\n\nKUniKIP|o|$Modus>";
			$minBool = <STDIN>;
			chomp $minBool;
			if ($minBool eq "y") {
			
				print "\nminimum parameter [Default = 0]:\n";
				print "min. amount of pupils: ";
				$minS = int(<STDIN>);
				print "min. amount of new schools: ";
				$minNSL = int(<STDIN>);
				print "min. amount of schools total: ";
				$minSL = int(<STDIN>);
				print "min. amount of dates: ";
				$minT = int(<STDIN>);
				
			}
			$x = $zeros4;
			$y = $zeros5;
			$z = $zeros6;
			$k = 1;
			$t = $zeros5;
			$ziel = "classes";
		
		}
		elsif($Modus eq "t")	{
		
			print "\ndefine minimum parameter? (y=yes)\n\nKUniKIP|o|$Modus>";
			$minBool = <STDIN>;
			chomp $minBool;
			if ($minBool eq "y") {
			
				print "\nminimum parameter [Default = 0]:\n";
				print "min. amount of pupils: ";
				$minS = int(<STDIN>);
				print "min. amount of new schools: ";
				$minNSL = int(<STDIN>);
				print "min. amount of schools total: ";
				$minSL = int(<STDIN>);
				print "min. amount of classes: ";
				$minK = int(<STDIN>);
				
			}
			$x = $zeros4;
			$y = $zeros5;
			$z = $zeros6;
			$k = $zeros6;
			$t = 1;
			$ziel = "dates";
		
		}
		else {
		
			print "\invalid target, try again\n";
			goto GET_MODUS;
		
		}
		
		print "\nsolving...\n";
		print LOG "determining data base upload:\n";
		print LOG "perl scripts/kip_main.pl -x $x -y $y -z $z -k $k -t $t -m $minNSL -n $minSL -o $minS -p $minK -q $minT";
		close(LOG);
		
		system("perl scripts/kip_main.pl -x $x -y $y -z $z -k $k -t $t -m $minNSL -n $minSL -o $minS -p $minK -q $minT 1>> $filenameLog 2>> $filenameError") == 0 or die "an error occured with scripts/kip_main.pl: $!\n";
		
        open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		
		print "-"x76,"\n";
		print "result for optimizing the amount of $ziel:\n";
	    
	    print LOG "-"x76,"\n";
		print LOG "result for optimizing the amount of $ziel:\n";
			
		#Ueberpruefung, ob eine Loesung gefunden wurde
		open(TEST,"output/kip_main.txt") or die "unable to open output/kip_main.txt: $!\n";
		my $solution_available = 1;
		while(<TEST>) {
			if($_ =~ /^no solution/) {
					$solution_available = 0;
			}
		}
		close(TEST);
			
		if($solution_available == 1) {
			
			open(DETAIL,"output/kip_main-detail.txt") or die "unable to open output/kip_main-detail.txt: $!\n";
			while(<DETAIL>)	{
				if($_ =~ /^assigned/) {print $_; print LOG $_;}
				if($_ =~ /^amount of new schools that were assigned/) {print $_; print LOG $_;}
				if($_ =~ /^amount of assigned schools total/) {print $_; print LOG $_;}
			}
			print "\nmore detail in output/kip_main-detail.txt\noutput/kip_main-db.txt contains the data base upload\n";
			print LOG "\nmore detail in output/kip_main-detail.txt\noutput/kip_main-db.txt contains the data base upload\n";
			close(DETAIL);
				
		}
		else {
			print "NO SOLUTION AVAILABLE!\n";
			print LOG "NO SOLUTION AVAILABLE!\n";
		}
		print "-"x76,"\n";
	    print LOG "-"x76,"\n";
	    
	    close(LOG); # force flush
	}
	
#separate Gap-Analyse	
	elsif($Eingabe eq "g")	{
	
	    print "analysing gap..."; # kip_gapAnalyzation will break line
	    print LOG "gap analysis:\n";
	    print LOG "perl scripts/kip_gapAnalyzation.pl -x 1 -y 0 -z 0 -k 0 -t 0\n";
	    close(LOG);
		
		system("perl scripts/kip_gapAnalyzation.pl -x 1 -y 0 -z 0 -k 0 -t 0  2>> $filenameError") == 0 or die "an error occured with scripts/kip_gapAnalyzation.pl: $!\n";
		
		open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		
		print "\n","-"x76,"\n";
		print LOG "\n","-"x76,"\n";
		open(GAP,"output/kip_gapAnalyzation.txt") or die "unable to open output/kip_gapAnalyzation.txt: $!\n";
		while(<GAP>){
			if($_ =~ /^capacity that/){
				print $_;
				print LOG $_;
			}
		}
		close(GAP);
		print "-"x76,"\n";
		print LOG "-"x76,"\n";
	
	    close(LOG); # force flush
	}
	
#eConstraint fuer neue Schulen vs Schueler	
	elsif($Eingabe eq "nl")	{
	
		print "examine amount of pupils versus new schools:\n";
		print "\t> determine minimum and maximum amounts of new schools...\n";
		
		print LOG "examine amount of pupils versus new schools:\n";
		print LOG "determine minimum and maximum amounts of new schools:\n";
		print LOG "perl scripts/kip_main.pl -x 1 -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5\n";
		close(LOG);
		
		system("perl scripts/kip_main.pl -x 1 -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5 1>> $filenameLog 2>> $filenameError") == 0 or die "an error occured with scripts/kip_main.pl: $!\n";
		open(FILE,"output/kip_main.txt") or die "unable to open output/kip_main.txt: $!\n";
		my $minNS;
		while(<FILE>)	{
			if($_ =~ /^yneu/){
				my @array = split " ",$_;
				$minNS=int($array[1]);
			}
		}
		close(FILE);
		
		open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		print LOG "perl scripts/kip_main.pl -x $zeros4 -y 1 -z $zeros6 -k $zeros6 -t $zeros5\n";
		close(LOG);
		
		system("perl scripts/kip_main.pl -x $zeros4 -y 1 -z $zeros6 -k $zeros6 -t $zeros5 1>> $filenameLog 2>> $filenameError") == 0 or die "an error occured with scripts/kip_main.pl: $!\n";
		open(FILE,"output/kip_main.txt") or die "unable to open output/kip_main.txt: $!\n";
		my $maxNS;
		while(<FILE>)	{
			if($_ =~ /^yneu/){
				my @array = split " ",$_;
				$maxNS=int($array[1]);
			}
		}
		close(FILE);
		
		open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		print "\t> solving model for nl = "; # eConstraint script will add line break
		print LOG "comparing:\n";
		print LOG "perl scripts/kip_eConstraint.pl -x 1 -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5 -l $minNS -u $maxNS\n";
		close(LOG);
		
		system("perl scripts/kip_eConstraint.pl -x 1 -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5 -l $minNS -u $maxNS 2>> $filenameError") == 0 or die "an error occured with scripts/kip_eConstrain.pl: $!\n";
		
		open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		print "-"x76,"\n";
		print LOG "-"x76,"\n";
		
		open(ECONST, "output/kip_eConstraint.txt") or die "unable to open output/kip_eConstraint.txt: $!\n";
		while (<ECONST>) {
			if($_ !~ /^generated/) {
				print $_;
				print LOG $_;
			}
		}
		close(ECONST);
		
		print "\noutput has been written into output/kip_eConstraint.txt\n";
		print LOG "\noutput has been written into output/kip_eConstraint.txt\n";
		
		print "-"x76,"\n";
		print LOG "-"x76,"\n";

        close(LOG); # force flush
	}
	
#eConstraint2 fuer Schulen vs Schueler
	elsif($Eingabe eq "l")	{
	
		print "examine amount of pupils versus schools total:\n";
		print "\t> determine minimum and maximum amounts of schools total...\n";
		
		print LOG "examine amount of pupils versus schools total:\n";
		print LOG "determine minimum and maximum amounts of schools total:\n";
		print LOG "perl scripts/kip_main.pl -x 1 -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5\n";
		close(LOG);
		
		system("perl scripts/kip_main.pl -x 1 -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5 1>> $filenameLog 2>> $filenameError") == 0 or die "an error occured with scripts/kip_main.pl: $!\n";
		open(FILE2,"output/kip_main.txt") or die "unable to open output/kip_main.txt: $!\n";
		my $minS;
		while(<FILE2>)	{
			if($_ =~ /^ysum/){
				my @array = split " ",$_;
				$minS=int($array[1]);
			}
		}
		close(FILE2);
		
		open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		print LOG "perl scripts/kip_main.pl -x $zeros4 -y $zeros5 -z 1 -k $zeros6 -t $zeros5\n";
		close(LOG);
		
		system("perl scripts/kip_main.pl -x $zeros4 -y $zeros5 -z 1 -k $zeros6 -t $zeros5 1>> $filenameLog 2>> $filenameError") == 0 or die "an error occured with scripts/kip_main.pl: $!\n";
		open(FILE2,"output/kip_main.txt") or die "unable to open output/kip_main.txt: $!\n";
		my $maxS;
		while(<FILE2>)	{
			if($_ =~ /^ysum/){
				my @array = split " ",$_;
				$maxS=int($array[1]);
			}
		}
		close(FILE2);
		
		open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		print "\t> solving model for l = "; # eConstraint script will add line break
		print LOG "comparing:\n";
		print LOG "perl scripts/kip_eConstraint2.pl -x 1 -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5 -l $minS -u $maxS\n";
		close(LOG);
		
		system("perl scripts/kip_eConstraint2.pl -x 1 -y $zeros5 -z $zeros6 -k $zeros6 -t $zeros5 -l $minS -u $maxS 2>> $filenameError") == 0 or die "an error occured with scripts/kip_eConstrain2.pl: $!\n";
		
		open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
		print "-"x76,"\n";
		print LOG "-"x76,"\n";

		open(ECONST2, "output/kip_eConstraint2.txt") or die "unable to open output/kip_eConstraint2.txt: $!\n";
		while (<ECONST2>) {
			if($_ !~ /^generated/) {
				print $_;
				print LOG $_;
			}
		}
		close(ECONST2);
		
		print "\noutput has been written into output/kip_eConstraint2.txt\n";
		print LOG "\noutput has been written into output/kip_eConstraint2.txt\n";
		
		print "-"x76,"\n";
		print LOG "-"x76,"\n";

        close(LOG); # force flush
	}
	
#Einzelbetrachtung der Termine mit Kapazitaetserhoehungen
	elsif($Eingabe eq "c")	{
	
		my $validID = 0;
		print "choose mode (s = single date, l = from list, else all)\n\nKUniKIP|c>";
		my $mode = <STDIN>;
		chomp $mode;
		if ($mode eq "s") {
		
			GET_TERMIN: #Sprungmarke
			print "enter date ID: ";
			my $TerminID = <STDIN>;
			chomp $TerminID;
			open(INPUT,"input/main.txt") or die "unable to open main.txt: $!\n";
			while(<INPUT>) {
			
				my @array = split " ",$_;
				if($array[0] eq "t" && $array[1] eq $TerminID) {
				
					$validID = 1;
				
				}
			
			}
			if($validID == 0) {
			
				print "unknown date ID $TerminID, try again:\n";
				goto GET_TERMIN; #Zur Termineingabe
			
			}
			else {
			
				print "\nincrease capacity for interval:\nminimum increase [>= 1] : ";
				my $minKap = int(<STDIN>);
				if($minKap < 1) {
				
					$minKap = 1;
					print "minimum increase set to 1!\n";
					
				}
				GET_MAXKAP_S: #Sprungmarke
				print "maximum increase [>= $minKap]: ";
				my $maxKap = int(<STDIN>);
				if($maxKap < $minKap){
				
					print "maximum increase has to be equal to or larger than minimum increase! try again:\n";
					goto GET_MAXKAP_S; #maxKap nochmal eingeben
				
				}
				
				print "\nrunning analysis for date $TerminID increasing the capacity by $minKap up to $maxKap...\n";
				print LOG "capacity increment analysis for date $TerminID increasing the capacity by $minKap up to $maxKap:\n";
				print LOG "perl scripts/kip_capacityIncrement.pl -x $zeros4 -y $zeros5 -z $zeros6 -k $zeros6 -t 1 -m $minKap -c $maxKap -o $TerminID\n";
				close(LOG);
				
				system("perl scripts/kip_capacityIncrement.pl -x $zeros4 -y $zeros5 -z $zeros6 -k $zeros6 -t 1 -m $minKap -c $maxKap -o $TerminID 2>> $filenameError") == 0 
					or die "an error occured with scripts/kip_capacityIncrement.pl: $!\n";
			}
		
		}
		elsif($mode eq "l") {
		    
		    print "\nrunning capacity increment analysis according to capIncrementCandidates.txt..."; # capacityIncrement script adds line break
			print LOG "capacity increment analysis according to capIncrementCandidates.txt:\n";
			print LOG "perl scripts/kip_capacityIncrement.pl -x $zeros4 -y $zeros5 -z $zeros6 -k $zeros6 -t 1 -l\n";
			close(LOG);
		    
		    system("perl scripts/kip_capacityIncrement.pl -x $zeros4 -y $zeros5 -z $zeros6 -k $zeros6 -t 1 -l 2>> $filenameError") == 0 or die "an error occured with scripts/kip_capacityIncrement.pl: $!\n";
		}
		else {
		
			print "\nincrease capacity for interval:\nminimum increase [>= 1] : ";
			my $minKap = int(<STDIN>);
			if($minKap < 1) {
				
				$minKap = 1;
				print "\n! minimum increase was set to 1 !\n\n";
					
			}
			GET_MAXKAP: #Sprungmarke
			print "maximum increase [>= $minKap]: ";
			my $maxKap = int(<STDIN>);
			if($maxKap < $minKap){
				
					print "\nmaximium increase has to be equal to or larger than minimum increase! try again:\n";
					goto GET_MAXKAP; #maxKap nochmal eingeben
				
			}
				
			print "\nrunning capacity increment analysis for all dates increasing the capacity by $minKap up to $maxKap:\n";
			print LOG "capacity increment analysis for all dates increasing the capacity by $minKap up to $maxKap:\n";
			print LOG "perl scripts/kip_capacityIncrement.pl -x $zeros4 -y $zeros5 -z $zeros6 -k $zeros6 -t 1 -m $minKap -c $maxKap\n";
			close(LOG);
			
			system("perl scripts/kip_capacityIncrement.pl -x $zeros4 -y $zeros5 -z $zeros6 -k $zeros6 -t 1 -m $minKap -c $maxKap 2>> $filenameError") == 0 or die "an error occured with scripts/kip_capacityIncrement.pl: $!\n";
		}
		
		print "="x76,"\noutput is located in output/kip_capacityIncrement.txt\n";
		if($mode eq "l") { print "generated capacity increment suggestions in capIncreaseSuggestion.txt\n"; }
		print "="x76,"\n";
	    open(LOG, ">>$filenameLog") or die "unable to open $filenameLog: $!\n";
	    print LOG "="x76,"\noutput is located in output/kip_capacityIncrement.txt\n";
	    if($mode eq "l") { print LOG "generated capacity increment suggestions in capIncreaseSuggestion.txt\n"; }
	    print LOG "="x76,"\n";
	    close(LOG); # force flush
	}
	
#Fehlermeldung fuer unbekannte Eingabe	
	else { print "'$Eingabe': unknown command\n"; }
}
